'------------------------------------------------------------------
'                           MAX6 test LCD clock
'                   By Jarek SP3SWJ  sp3swj@gmail.com
'                   Created with Bascom-Avr: 1.11.9.3
'------------------------------------------------------------------



$regfile = "m128def.dat"

$crystal = 11059200
$baud = 115200                                              ' use baud rate


$loadersize = 1024

'$hwstack = 128
'$swstack = 128
'$framesize = 196


'some routines to control the display are in the glcdKS108.lib file
'First we define that we use a graphic  LCD KS0108
$lib "glcdKS108.lbx"
Config Graphlcd = 128 * 64sed , Dataport = Porta , Controlport = Portc , Ce = 7 , Ce2 = 6 , Cd = 3 , Rd = 4 , Reset = 5 , Enable = 2


Enable Interrupts


'[now init the clock]
Config Date = Ymd , Separator = -                           ' ANSI-Format

Config Clock = Soft                                         'this is how simple it is
'The above statement will bind in an ISR so you can not use the TIMER anymore!




Config Timer1 = Pwm , Prescale = 1 , Pwm = 8 , Compare B Pwm = Clear Down




'The AUTO feature, will select the highest clockrate possible
Config Adc = Single , Prescaler = Auto




Config Pinb.4 = Input                                       '1=on-MAX  0=0ff-MAX  - start OFF
Key_power_on Alias Pinb.4
Key_power_on_pullup Alias Portb.4


Config Portb.5 = Output
Buzer Alias Portb.5


'use as PWM backlit output  Portb.6






'POWER on SWITCH 1=ON
Config Porte.7 = Output
Switch_power_on Alias Porte.7                               'ON=1  OFF=0


Config Pine.2 = Input
Key_function Alias Pine.2
Key_function_pullup Alias Porte.2

Config Pine.3 = Input
Key_mode Alias Pine.3
Key_mode_pullup Alias Porte.3

Config Pine.4 = Input
Key_down Alias Pine.4
Key_down_pullup Alias Porte.4

Config Pine.5 = Input
Key_up Alias Pine.5
Key_up_pullup Alias Porte.5

Config Pind.1 = Input                                       ' USB=0 LCD=1
Key_lcd_mode Alias Pind.1
Key_lcd_mode_pullup Alias Portd.1



'===============================================================================


Dim Lcd_light As Byte
Dim Second_old As Byte




'==============================   START   ======================================



Cls

'provide pull-up for KEYBOARD
Set Key_function_pullup
Set Key_down_pullup
Set Key_up_pullup
Set Key_mode_pullup

Set Key_power_on_pullup
Set Key_lcd_mode_pullup

Lcd_light = 0


Setfont Font16x16
Reset Switch_power_on
Lcdat 2 , 1 , "HOLD PWR"
Wait 1

Pwm1b = Lcd_light

Set Switch_power_on
Lcdat 2 , 1 , "RELASE !"

Wait 1


'assign the date to the reserved date$
'The format is YY/MM/DD
Date$ = "09/04/30"

'assign the time, format in hh:mm:ss military format(24 hours)
'You may not use 1:2:3 !! adding support for this would mean overhead
'But of course you can alter the library routines used

Time$ = "23:58:00"


Cls

'switch on backlit
Pwm1b = Lcd_light

Setfont Font8x8
Lcdat 8 , 1 , " d-  d+  m-  m+ " , 1

Setfont Font16x16


'=================================================
Do

'switch on backlit
Pwm1b = Lcd_light

Lcdat 2 , 1 , Date$
Lcdat 5 , 1 , Time$


If Second_old <> _sec Then

   'send every second to COM port
   Print Date$ ; Spc(3) ; Time$

   Set Buzer
   Waitms 1
   Reset Buzer
   Waitms 1
   Lcd_light = 0

End If


Second_old = _sec

Lcd_light = Lcd_light + 4


   If Key_power_on = 0 Then Reset Switch_power_on

   If Key_lcd_mode = 0 Then Reset Switch_power_on


   If Key_down = 0 Or Key_up = 0 Or Key_function = 0 Or Key_mode = 0 Then Waitms 50


   If Key_mode = 0 Then Decr _day
   If Key_function = 0 Then Incr _day
   If Key_down = 0 Then Decr _min
   If Key_up = 0 Then Incr _min





   If _min = -1 Then
     _min = 59
     Decr _hour
   End If

   If _min = 60 Then
     _min = 0
     Incr _hour
   End If

   If _hour = -1 Then
     _hour = 23
   End If

   If _hour = 24 Then
     _hour = 0
   End If



   If _day = 0 Then
     _day = 31
     Decr _month
   End If

   If _day = 32 Then
     _day = 1
     Incr _month
   End If

   If _month = 0 Then
      _month = 12
   End If

   If _month = 13 Then
      _month = 1
   End If


Loop




'----------------------------

$include "font8x8.font"
$include "font16x16.font"